#include <windows.h>
#include <stdio.h>

//#include "ScriptInterpreter.h"
//#include "ScriptError.h"
//#include "ScriptValue.h"

//#include "resource.h"
#include "../include/filter.h"

///////////////////////////////////////////////////////////////////////////

int tutorialRunProc(const FilterActivation *fa, const FilterFunctions *ff);
long tutorialParamProc(FilterActivation *fa, const FilterFunctions *ff);

///////////////////////////////////////////////////////////////////////////




struct FilterDefinition filterDef_tutorial = {

    NULL, NULL, NULL,       // next, prev, module
    "Zero Pad",             // name
    "Put zero pixels between cols and rows",
                            // desc
    "trevlac",               // maker
    NULL,                   // private_data
    0,   // inst_data_size

    NULL,                   // initProc
    NULL,                   // deinitProc
    tutorialRunProc,        // runProc
    tutorialParamProc,      // paramProc
    NULL,     // configProc
    NULL,     // stringProc
    NULL,      // startProc
    NULL,        // endProc

    NULL,          // script_obj
    NULL,        // fssProc

};

///////////////////////////////////////////////////////////////////////////

extern "C" int __declspec(dllexport) __cdecl VirtualdubFilterModuleInit2(FilterModule *fm, const FilterFunctions *ff, int& vdfd_ver, int& vdfd_compat);
extern "C" void __declspec(dllexport) __cdecl VirtualdubFilterModuleDeinit(FilterModule *fm, const FilterFunctions *ff);

static FilterDefinition *fd_tutorial;

///////////////////////////////////////////////////////////////////////////

int __declspec(dllexport) __cdecl VirtualdubFilterModuleInit2(FilterModule *fm, const FilterFunctions *ff, int& vdfd_ver, int& vdfd_compat) {
    if (!(fd_tutorial = ff->addFilter(fm, &filterDef_tutorial, sizeof(FilterDefinition))))
        return 1;

	vdfd_ver = VIRTUALDUB_FILTERDEF_VERSION;
	vdfd_compat = VIRTUALDUB_FILTERDEF_COMPATIBLE;

    return 0;
}

void __declspec(dllexport) __cdecl VirtualdubFilterModuleDeinit(FilterModule *fm, const FilterFunctions *ff) {
    ff->removeFilter(fd_tutorial);
}

///////////////////////////////////////////////////////////////////////////


int tutorialRunProc(const FilterActivation *fa, const FilterFunctions *ff) {
    PixDim w, h;
    Pixel32 *src, *dst;

    src = (Pixel32 *)fa->src.data;
    dst = (Pixel32 *)fa->dst.data;

    h = fa->src.h;
    do {
        w = fa->src.w;

		do {
			*dst++ = *src++;
			*dst++ = 0; 0x00808080;
		} while(--w);

        src = (Pixel32 *)((char *)src + fa->src.modulo);
	    dst = (Pixel32 *)((char *)dst + fa->dst.modulo);

 /*       w = fa->src.w;
		do {
			*dst++ = 0; 0x00808080;
			*dst++ = 0; 0x00808080;
		} while(--w);

	    dst = (Pixel32 *)((char *)dst + fa->dst.modulo);
*/
    } while(--h);

    return 0;
}




long tutorialParamProc(FilterActivation *fa, const FilterFunctions *ff) {
    fa->dst.w *= 2;
    //fa->dst.h *= 2;
	fa->dst.pitch = (fa->dst.w*4 + 7) & -8;

    return FILTERPARAM_SWAP_BUFFERS;
}


